#include <complex.h>
	
#define Complex complex<double>

#define MSQRT2   M_SQRT2
#define MSQRT12  M_SQRT1_2

#define RAT  0.3894*2
#define FEMTOBARN  0.3894

typedef double* vector4;
typedef const double* cvector4;

double sqr(double x);
void swap(vector4 a, vector4 b);

vector4 P(cvector4 v);
double Dot(cvector4 a, cvector4 b);
void Boost(cvector4 v, cvector4 p, vector4 vboost);

double PseudoDelta(Complex ps, double ms);
// Complex Prop(double ps, double ms, double mg);
Complex Prop(Complex ps, Complex ms, Complex mg);
double lambda(double m1s, double m2s, double m3s);

void TwoDecay(double m, double m1, double m2, double costheta, double phi,
		vector4 p1, vector4 p2, double *factor);
double _TwoDecay(double m, double m1, double m2, double costheta, double phi,
		vector4 p1, vector4 p2);
void SplitMom(cvector4 k, vector4 p1, vector4 p2);

Complex S(cvector4 x, cvector4 y);
Complex T(cvector4 x, cvector4 y);
